diff -ruN vdr-1.7.31/CONTRIBUTORS vdr-1.7.32/CONTRIBUTORS
--- vdr-1.7.31/CONTRIBUTORS	2012-09-29 12:05:49.000000000 +0200
+++ vdr-1.7.32/CONTRIBUTORS	2012-11-18 14:12:31.000000000 +0100
@@ -1757,6 +1757,9 @@
  for adding the option --outputonly to the dvbsddevice plugin
  for adding a missing template specification to the c'tor of cSortedTimers
  for contributing to a patch that implements FHS support
+ for suggesting to check cIoThrottle::Engaged() in cRemoveDeletedRecordingsThread::Action()
+ for suggesting to shift editing marks that don't point to an I-frame towards the next I-frame
+ when a recording is played
 
 Sven Kreiensen <svenk@kammer.uni-hannover.de>
  for his help in keeping 'channels.conf.terr' up to date
@@ -2305,6 +2308,8 @@
  for fixing cRecording::LengthInSeconds(), which wrongfully rounded the result to full
  minutes
  for suggesting to check for NULL in cOsd::AddPixmap()
+ for making modified editing marks be written to disk whenever the replay progress
+ display gets hidden
 
 Pekka Mauno <pekka.mauno@iki.fi>
  for fixing cSchedule::GetFollowingEvent() in case there is currently no present
@@ -2314,6 +2319,8 @@
  for fixing the shutdown timeout
  for making the script given to VDR with the '-r' option be also called whenever a
  recording is deleted
+ for making pressing the Play key during normal live viewing mode open the Recordings
+ menu if there is no "last viewed" recording
 
 Jan Lenz <email@JanLenz.de>
  for reporting a bug in deleting recordings that have been removed externally when
@@ -2618,6 +2625,7 @@
  for reporting a problem with the function cString::sprintf(const char *fmt, va_list &ap),
  that might inadvertently be called with a 'char *' as the second argument on some
  compilers and cause a crash
+ for reporting a possible memory leak in SI::StructureLoop::getNextAsPointer()
 
 Ales Jurik <ajurik@quick.cz>
  for reporting broken SI data on Czech/Slovak channels after changing the default
@@ -2692,6 +2700,7 @@
  several payloads
  for reporting a problem with getting the maximum short channel name length in case there
  are no short names at all
+ for reporting an incompatible change from DTV_DVBT2_PLP_ID to DTV_STREAM_ID in DVB API 5.8
 
 Marcel Unbehaun <frostworks@gmx.de>
  for adding cRecordingInfo::GetEvent()
@@ -2895,6 +2904,7 @@
  in case buffers run full
  for suggesting to increase the size of the TS buffer to 5MB and that of the Recorder
  buffer to 20MB to better handle HD recordings
+ for fixing setting the video format in the dvbhdffdevice
 
 Christian Ruppert <idl0r@gentoo.org>
  for some improvements to the Makefiles
@@ -2960,3 +2970,6 @@
  for a patch that was used to move cleaning up the EPG data and writing the epg.data
  file into a separate thread to avoid sluggish response to user input on slow systems
  for fixing sorting folders before recordings in case of UTF-8
+
+Peter Münster <pmlists@free.fr>
+ for fixing 'make install' to not overwrite existing configuration files
diff -ruN vdr-1.7.31/HISTORY vdr-1.7.32/HISTORY
--- vdr-1.7.31/HISTORY	2012-09-30 13:07:48.000000000 +0200
+++ vdr-1.7.32/HISTORY	2012-11-18 14:11:56.000000000 +0100
@@ -7271,3 +7271,70 @@
   whether a directory is empty. This allows users to continue to use files such as
   ".keep" to prevent a directory from being deleted when it is empty. Currently the
   only file name that is ignored is ".sort".
+
+2012-11-18: Version 1.7.32
+
+- Pressing the Play key during normal live viewing mode now opens the Recordings menu
+  if there is no "last viewed" recording (thanks to Alexander Wenzel).
+  The same behavior has been implemented for the Blue key in the main menu.
+- cIoThrottle::Engaged() is now also checked in cRemoveDeletedRecordingsThread::Action(),
+  to suspend removing deleted recordings in case this is necessary to make room for
+  new, ongoing recordings (suggested by Udo Richter).
+- The cThread constructor now has an additional boolean parameter that can be set to
+  true to have this thread run at a lower priority. Plugin authors that use low
+  priority threads may want to use this instead of the calls to SetPriority(19) and
+  SetIOPriority(7). The priority of a thread ("low" or "high") is now logged when the
+  thread starts.
+- Changed DTV_DVBT2_PLP_ID to DTV_STREAM_ID in dvbdevice.c to adapt to an incompatible
+  change in DVB API 5.8 (reported by Derek Kelly).
+  Removed the meanwhile obsolete definition of FE_CAN_TURBO_FEC.
+- Fixed some compiler warnings under gcc version 4.7.1.
+- Fixed setting the video format in the dvbhdffdevice (thanks to Torsten Lang).
+- Fixed 'make install' to not overwrite existing configuration files (thanks to Peter
+  Münster).
+- Added including the Make.global and Make.config files to the dvbdhffdevice's
+  libhdffcmd/Makefile.
+- Added options to build a 32-bit version of VDR on a 64-bit machine to
+  Make.config.template.
+- Fixed handling VPS timers in case the running status of an event goes to '1' (not
+  running) and later goes to '4' (running).
+- If a frame position in the 'marks' file of a recording doesn't point to an I-frame,
+  it will now be shifted towards the next I-frame, either up or down, whichever is
+  closer (suggested by Udo Richter).
+- Fixed a possible memory leak in SI::StructureLoop::getNextAsPointer() (reported by
+  Sundararaj Reel).
+- Fixed handling timers in case an event is modified and "phased out" while the timer
+  is recording.
+- Improved frame detection by parsing just far enough into the MPEG-4 NAL units to get
+  the necessary information about frames and slices.
+- The initial syncing of the frame detector is now done immediately after the first
+  complete GOP has been seen. This makes recordings and especially pausing live video
+  start up to twice as fast as before.
+- Updated the Romanian OSD texts (thanks to Lucian Muresan).
+- Fixed handling the very last entry in a recording index.
+- The return type of cMarks::Add() has been changed to void, since due to the sorting
+  of the list of marks the returned pointer might have pointed to a totally different
+  mark. Besides, the return value was never actually used.
+- Improved editing TS recordings by
+  + stripping dangling TS packets from the beginning of a sequence
+  + including pending TS packets at the end of a sequence
+  + fixing all timestamps and continuity counters
+  + generating editing marks for the edited version in such a way that each cutting
+    point is marked by an "end" and "begin" mark with the same offset
+  + no longer generating an editing mark at the "end" of the edited recording (this
+    was actually generated at the beginning of the last GOP, so that a subsequent
+    edit would have cut off the last GOP)
+  + no longer generating any editing marks if the edited recording results on just
+    one single sequence
+  + ignoring pairs of editing marks that are placed at exactly the same position of
+    a recording when actually cutting the recording
+  + not doing anything if the editing marks in place would result in the edited
+    version being the same as the original recording
+- Editing marks can now be placed directly on top of each other, in which case they
+  simply mark a position, but have no effect on the actual cutting process.
+- When positioned at an offset where two (or more) editing marks are placed on top
+  of each other, the '4' key moves the first one of them to the left, while the '6'
+  key moves the last one of them to the right. The '7' and '9' key handle multiple
+  marks at the same place as if it were one single mark.
+- Modified editing marks are now written to disk whenever the replay progress display
+  gets hidden (thanks to Christoph Haubrich).
diff -ruN vdr-1.7.31/INSTALL vdr-1.7.32/INSTALL
--- vdr-1.7.31/INSTALL	2012-09-17 11:00:43.000000000 +0200
+++ vdr-1.7.32/INSTALL	2012-10-09 12:43:28.000000000 +0200
@@ -36,6 +36,10 @@
 named 'vdr', which can be run after the DVB driver has been
 installed.
 
+If you want to build a 32-bit version of VDR on a 64-bit machine, you can
+use 'make M32=1' to do so. Note that you also need to have a Make.config file
+(derived from Make.config.template) to make this work.
+
 IMPORTANT: See "Configuration files" below for information on how
 =========  to set up the configuration files at the proper location!
 
diff -ruN vdr-1.7.31/MANUAL vdr-1.7.32/MANUAL
--- vdr-1.7.31/MANUAL	2012-09-15 15:50:06.000000000 +0200
+++ vdr-1.7.32/MANUAL	2012-11-13 13:09:38.000000000 +0100
@@ -367,13 +367,13 @@
   - 7, 9    Jump back and forward between editing marks. Replay goes into still
             mode after jumping to a mark.
   - 8       Positions replay at a point 3 seconds before the current or next
-            "start" mark and starts replay.
+            "begin" mark and starts replay.
   - 2       Start the actual cutting process.
 
   Editing marks are represented by black, vertical lines in the progress display.
-  A small black triangle at the top of the mark means that this is a "start"
+  A small black triangle at the top of the mark means that this is a "begin"
   mark, and a triangle at the bottom means that this is an "end" mark.
-  The cutting process will save all video data between "start" and "end" marks
+  The cutting process will save all video data between "begin" and "end" marks
   into a new file (the original recording remains untouched). The new file will
   have the same name as the original recording, preceded with a '%' character
   (imagine the '%' somehow looking like a pair of scissors ;-). Red bars in the
@@ -382,7 +382,7 @@
 
   The video sequences to be saved by the cutting process are determined by an
   "even/odd" algorithm. This means that every odd numbered editing mark (i.e.
-  1, 3, 5,...) represents a "start" mark, while every even numbered mark (2, 4,
+  1, 3, 5,...) represents a "begin" mark, while every even numbered mark (2, 4,
   6,...) is an "end" mark. Inserting or toggling a mark on or off automatically
   adjusts the sequence to the right side of that mark.
 
@@ -395,11 +395,13 @@
   version of the recording you can use the '8' key to jump to a point just
   before the next cut and have a look at the resulting sequence.
 
-  Currently editing marks can only be set at I-frames, which typically is
-  every 12th frame. So editing can be done with a resolution of roughly half
-  a second. A "start" mark marks the first frame of a resulting video
-  sequence, and an "end" mark marks the last frame of that sequence.
-
+  Currently editing marks can only be set at I-frames, which typically appear
+  every half of a second to a second.  A "begin" mark marks the first frame of
+  a resulting video sequence, and an "end" mark marks the last frame of that
+  sequence.  Note that the actual frame indicated by the an "end" mark will
+  not be included in the edited version of the recording. That's because every
+  recording (and every sequence of an edited recording) begins with an I-frame
+  and ends right before the next I-frame.
   An edited recording (indicated by the '%' character) will never be deleted
   automatically in case the disk runs full (no matter what "lifetime" it has).
 
diff -ruN vdr-1.7.31/Make.config.template vdr-1.7.32/Make.config.template
--- vdr-1.7.31/Make.config.template	2012-09-01 12:31:33.000000000 +0200
+++ vdr-1.7.32/Make.config.template	2012-10-09 12:32:32.000000000 +0200
@@ -6,7 +6,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Make.config.template 2.9 2012/09/01 10:31:33 kls Exp $
+# $Id: Make.config.template 2.10 2012/10/09 10:32:32 kls Exp $
 
 ### The C compiler and options:
 
@@ -21,6 +21,12 @@
 CXXFLAGS += -fPIC
 endif
 
+# Use 'make M32=1 ...' to build a 32-bit version of VDR on a 64-bit machine:
+ifdef M32
+CFLAGS   += -m32
+CXXFLAGS += -m32
+endif
+
 ### The directory environment:
 
 PREFIX   = $(DESTDIR)/usr/local
diff -ruN vdr-1.7.31/Makefile vdr-1.7.32/Makefile
--- vdr-1.7.31/Makefile	2012-09-07 16:11:37.000000000 +0200
+++ vdr-1.7.32/Makefile	2012-10-09 10:32:25.000000000 +0200
@@ -4,7 +4,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Makefile 2.29 2012/09/07 14:11:37 kls Exp $
+# $Id: Makefile 2.30 2012/10/09 08:32:25 kls Exp $
 
 .DELETE_ON_ERROR:
 
@@ -211,7 +211,7 @@
 	@mkdir -p $(DESTDIR)$(RESDIRDEF)
 
 install-conf:
-	@cp *.conf $(DESTDIR)$(CONFDIRDEF)
+	@cp -n *.conf $(DESTDIR)$(CONFDIRDEF)
 
 
 # Documentation:
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/dvbhdffdevice.c vdr-1.7.32/PLUGINS/src/dvbhddevice/dvbhdffdevice.c
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2012-05-08 13:40:32.000000000 +0200
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/dvbhdffdevice.c	2012-11-15 10:19:10.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbhdffdevice.c 1.43 2012/05/08 11:40:32 kls Exp $
+ * $Id: dvbhdffdevice.c 1.46 2012/11/15 09:19:10 kls Exp $
  */
 
 #include <stdint.h>
@@ -69,6 +69,7 @@
 
      mHdffCmdIf->CmdAvSetAudioDelay(gHdffSetup.AudioDelay);
      mHdffCmdIf->CmdAvSetAudioDownmix((HdffAudioDownmixMode_t) gHdffSetup.AudioDownmix);
+     mHdffCmdIf->CmdAvSetSyncShift(gHdffSetup.AvSyncShift);
      mHdffCmdIf->CmdMuxSetVideoOut((HdffVideoOut_t) gHdffSetup.AnalogueVideo);
      mHdffCmdIf->CmdHdmiSetVideoMode(gHdffSetup.GetVideoMode());
 
@@ -136,7 +137,7 @@
 {
   HdffVideoFormat_t videoFormat;
   videoFormat.AutomaticEnabled = true;
-  videoFormat.AfdEnabled = true;
+  videoFormat.AfdEnabled = false;
   videoFormat.TvFormat = (HdffTvFormat_t) gHdffSetup.TvFormat;
   videoFormat.VideoConversion = (HdffVideoConversion_t) gHdffSetup.VideoConversion;
   mHdffCmdIf->CmdAvSetVideoFormat(0, &videoFormat);
@@ -375,62 +376,86 @@
 
 bool cDvbHdFfDevice::SetPlayMode(ePlayMode PlayMode)
 {
-  if (PlayMode == pmNone) {
-     mHdffCmdIf->CmdAvSetVideoSpeed(0, 100);
-     mHdffCmdIf->CmdAvSetAudioSpeed(0, 100);
-
-     mHdffCmdIf->CmdAvEnableVideoAfterStop(0, false);
-     mHdffCmdIf->CmdAvSetPcrPid(0, 0);
-     mHdffCmdIf->CmdAvSetVideoPid(0, 0, HDFF_VIDEO_STREAM_MPEG1);
-     mHdffCmdIf->CmdAvSetAudioPid(0, 0, HDFF_AUDIO_STREAM_MPEG1);
-
-     ioctl(fd_video, VIDEO_SELECT_SOURCE, VIDEO_SOURCE_DEMUX);
-     mHdffCmdIf->CmdAvSetDecoderInput(0, 0);
-     mHdffCmdIf->CmdAvEnableSync(0, true);
-     mHdffCmdIf->CmdAvSetPlayMode(0, true);
-     }
-  else {
-     if (playMode == pmNone)
-        TurnOffLiveMode(true);
+    if (PlayMode == pmNone) {
+        if (fd_video == -1)
+            fd_video = DvbOpen(DEV_DVB_VIDEO,  adapter, frontend, O_RDWR | O_NONBLOCK);
+        if (fd_audio == -1)
+            fd_audio = DvbOpen(DEV_DVB_AUDIO,  adapter, frontend, O_RDWR | O_NONBLOCK);
+
+        mHdffCmdIf->CmdAvSetVideoSpeed(0, 100);
+        mHdffCmdIf->CmdAvSetAudioSpeed(0, 100);
+
+        mHdffCmdIf->CmdAvEnableVideoAfterStop(0, false);
+        mHdffCmdIf->CmdAvSetPcrPid(0, 0);
+        mHdffCmdIf->CmdAvSetVideoPid(0, 0, HDFF_VIDEO_STREAM_MPEG1);
+        mHdffCmdIf->CmdAvSetAudioPid(0, 0, HDFF_AUDIO_STREAM_MPEG1);
+
+        ioctl(fd_video, VIDEO_SELECT_SOURCE, VIDEO_SOURCE_DEMUX);
+        mHdffCmdIf->CmdAvSetDecoderInput(0, 0);
+        mHdffCmdIf->CmdAvEnableSync(0, true);
+        mHdffCmdIf->CmdAvSetPlayMode(0, true);
+    }
+    else {
+        if (playMode == pmNone)
+            TurnOffLiveMode(true);
 
-     mHdffCmdIf->CmdAvSetPlayMode(1, Transferring() || (cTransferControl::ReceiverDevice() == this));
-     mHdffCmdIf->CmdAvSetStc(0, 100000);
-     mHdffCmdIf->CmdAvEnableSync(0, true);
-     mHdffCmdIf->CmdAvEnableVideoAfterStop(0, true);
-
-     playVideoPid = -1;
-     playAudioPid = -1;
-     audioCounter = 0;
-     videoCounter = 0;
-     freezed = false;
-     trickMode = false;
-
-     mHdffCmdIf->CmdAvSetDecoderInput(0, 2);
-     ioctl(fd_video, VIDEO_SELECT_SOURCE, VIDEO_SOURCE_MEMORY);
-     }
-  playMode = PlayMode;
-  return true;
+        if (PlayMode == pmExtern_THIS_SHOULD_BE_AVOIDED)
+        {
+            close(fd_video);
+            fd_video = -1;
+            close(fd_audio);
+            fd_audio = -1;
+        }
+        else
+        {
+            mHdffCmdIf->CmdAvSetPlayMode(1, Transferring() || (cTransferControl::ReceiverDevice() == this));
+            mHdffCmdIf->CmdAvSetStc(0, 100000);
+            mHdffCmdIf->CmdAvEnableSync(0, false);
+            mHdffCmdIf->CmdAvEnableVideoAfterStop(0, true);
+
+            playVideoPid = -1;
+            playAudioPid = -1;
+            audioCounter = 0;
+            videoCounter = 0;
+            freezed = false;
+            trickMode = false;
+            isPlayingVideo = false;
+
+            mHdffCmdIf->CmdAvSetDecoderInput(0, 2);
+            ioctl(fd_video, VIDEO_SELECT_SOURCE, VIDEO_SOURCE_MEMORY);
+	}
+    }
+    playMode = PlayMode;
+    return true;
 }
 
 int64_t cDvbHdFfDevice::GetSTC(void)
 {
-  if (fd_video >= 0) {
-     uint64_t pts;
-     if (ioctl(fd_video, VIDEO_GET_PTS, &pts) == -1) {
-        esyslog("ERROR: pts %d: %m", CardIndex() + 1);
-        return -1;
+    if (isPlayingVideo)
+    {
+        if (fd_video >= 0) {
+            uint64_t pts;
+            if (ioctl(fd_video, VIDEO_GET_PTS, &pts) == -1) {
+                esyslog("ERROR: pts %d: %m", CardIndex() + 1);
+                return -1;
+            }
+            //printf("video PTS %lld\n", pts);
+            return pts;
         }
-     return pts;
-     }
-  if (fd_audio >= 0) {
-     uint64_t pts;
-     if (ioctl(fd_audio, AUDIO_GET_PTS, &pts) == -1) {
-        esyslog("ERROR: pts %d: %m", CardIndex() + 1);
-        return -1;
+    }
+    else
+    {
+        if (fd_audio >= 0) {
+            uint64_t pts;
+            if (ioctl(fd_audio, AUDIO_GET_PTS, &pts) == -1) {
+                esyslog("ERROR: pts %d: %m", CardIndex() + 1);
+                return -1;
+            }
+            //printf("audio PTS %lld\n", pts);
+            return pts;
         }
-     return pts;
-     }
-  return -1;
+    }
+    return -1;
 }
 
 void cDvbHdFfDevice::TrickSpeed(int Speed)
@@ -456,12 +481,13 @@
 
 void cDvbHdFfDevice::Play(void)
 {
-  freezed = false;
-  trickMode = false;
-  mHdffCmdIf->CmdAvEnableSync(0, true);
-  mHdffCmdIf->CmdAvSetVideoSpeed(0, 100);
-  mHdffCmdIf->CmdAvSetAudioSpeed(0, 100);
-  cDevice::Play();
+    freezed = false;
+    trickMode = false;
+    if (isPlayingVideo)
+        mHdffCmdIf->CmdAvEnableSync(0, true);
+    mHdffCmdIf->CmdAvSetVideoSpeed(0, 100);
+    mHdffCmdIf->CmdAvSetAudioSpeed(0, 100);
+    cDevice::Play();
 }
 
 void cDvbHdFfDevice::Freeze(void)
@@ -631,6 +657,11 @@
 {
     if (freezed)
         return -1;
+    if (!isPlayingVideo)
+    {
+        mHdffCmdIf->CmdAvEnableSync(0, true);
+        isPlayingVideo = true;
+    }
     //TODO: support greater Length
     uint8_t tsBuffer[188 * 16];
     uint32_t tsLength;
@@ -651,8 +682,6 @@
 {
     if (freezed)
         return -1;
-    if (trickMode)
-        return Length;
     uint8_t streamId;
     uint8_t tsBuffer[188 * 16];
     uint32_t tsLength;
@@ -702,17 +731,23 @@
 
 int cDvbHdFfDevice::PlayTsVideo(const uchar *Data, int Length)
 {
-  if (freezed)
-    return -1;
-  int pid = TsPid(Data);
-  if (pid != playVideoPid) {
-     PatPmtParser();
-     if (pid == PatPmtParser()->Vpid()) {
-        playVideoPid = pid;
-        mHdffCmdIf->CmdAvSetVideoPid(0, playVideoPid, MapVideoStreamTypes(PatPmtParser()->Vtype()), true);
+    if (freezed)
+        return -1;
+    if (!isPlayingVideo)
+    {
+        mHdffCmdIf->CmdAvEnableSync(0, true);
+        isPlayingVideo = true;
+    }
+
+    int pid = TsPid(Data);
+    if (pid != playVideoPid) {
+        PatPmtParser();
+        if (pid == PatPmtParser()->Vpid()) {
+            playVideoPid = pid;
+            mHdffCmdIf->CmdAvSetVideoPid(0, playVideoPid, MapVideoStreamTypes(PatPmtParser()->Vtype()), true);
         }
-     }
-  return WriteAllOrNothing(fd_video, Data, Length, 1000, 10);
+    }
+    return WriteAllOrNothing(fd_video, Data, Length, 1000, 10);
 }
 
 static HdffAudioStreamType_t MapAudioStreamTypes(int Atype)
@@ -732,8 +767,6 @@
 {
   if (freezed)
     return -1;
-  if (trickMode)
-    return Length;
   int pid = TsPid(Data);
   if (pid != playAudioPid) {
      playAudioPid = pid;
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/dvbhdffdevice.h vdr-1.7.32/PLUGINS/src/dvbhddevice/dvbhdffdevice.h
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/dvbhdffdevice.h	2011-09-10 12:17:32.000000000 +0200
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/dvbhdffdevice.h	2012-11-05 09:49:29.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: dvbhdffdevice.h 1.7 2011/09/10 10:17:32 kls Exp $
+ * $Id: dvbhdffdevice.h 1.8 2012/11/05 08:49:29 kls Exp $
  */
 
 #ifndef __DVBHDFFDEVICE_H
@@ -81,6 +81,7 @@
   int playAudioPid;
   bool freezed;
   bool trickMode;
+  bool isPlayingVideo;
 
   // Pes2Ts conversion stuff
   uint8_t videoCounter;
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/hdffcmd.c vdr-1.7.32/PLUGINS/src/dvbhddevice/hdffcmd.c
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/hdffcmd.c	2012-06-16 13:16:38.000000000 +0200
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/hdffcmd.c	2012-11-15 10:19:47.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hdffcmd.c 1.25 2012/06/16 11:16:38 kls Exp $
+ * $Id: hdffcmd.c 1.26 2012/11/15 09:19:47 kls Exp $
  */
 
 #include <stdint.h>
@@ -170,6 +170,11 @@
     HdffCmdAvSetAudioChannel(mOsdDev, AudioChannel);
 }
 
+void cHdffCmdIf::CmdAvSetSyncShift(int16_t SyncShift)
+{
+    HdffCmdAvSetSyncShift(mOsdDev, SyncShift);
+}
+
 
 void cHdffCmdIf::CmdOsdConfigure(const HdffOsdConfig_t * pConfig)
 {
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/hdffcmd.h vdr-1.7.32/PLUGINS/src/dvbhddevice/hdffcmd.h
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/hdffcmd.h	2012-06-16 13:16:52.000000000 +0200
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/hdffcmd.h	2012-11-15 10:20:05.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hdffcmd.h 1.20 2012/06/16 11:16:52 kls Exp $
+ * $Id: hdffcmd.h 1.21 2012/11/15 09:20:05 kls Exp $
  */
 
 #ifndef _HDFF_CMD_H_
@@ -47,6 +47,7 @@
     void CmdAvSetAudioDelay(int16_t Delay);
     void CmdAvSetAudioDownmix(HdffAudioDownmixMode_t DownmixMode);
     void CmdAvSetAudioChannel(uint8_t AudioChannel);
+    void CmdAvSetSyncShift(int16_t SyncShift);
 
     void CmdOsdConfigure(const HdffOsdConfig_t * pConfig);
     void CmdOsdReset(void);
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/hdffosd.c vdr-1.7.32/PLUGINS/src/dvbhddevice/hdffosd.c
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/hdffosd.c	2012-06-16 13:17:11.000000000 +0200
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/hdffosd.c	2012-11-15 10:20:24.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: hdffosd.c 1.17 2012/06/16 11:17:11 kls Exp $
+ * $Id: hdffosd.c 1.18 2012/11/15 09:20:24 kls Exp $
  */
 
 #include "hdffosd.h"
@@ -390,11 +390,13 @@
             }
         }
     }
+#if 0
     if (mSupportsUtf8Text)
     {
         mHdffCmdIf->CmdOsdDrawUtf8Text(mDisplay, pFont->Handle, x + mLeft, y + mTop + h, s, ColorFg);
     }
     else
+#endif
     {
         uint16_t tmp[1000];
         uint16_t len = 0;
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/libhdffcmd/Makefile vdr-1.7.32/PLUGINS/src/dvbhddevice/libhdffcmd/Makefile
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/libhdffcmd/Makefile	2012-01-18 13:25:20.000000000 +0100
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/libhdffcmd/Makefile	2012-10-09 11:54:26.000000000 +0200
@@ -24,6 +24,18 @@
 AR      ?= ar
 ARFLAGS ?= r
 
+### The directory environment:
+
+VDRDIR ?= ../../../..
+
+### Make sure that necessary options are included:
+
+include $(VDRDIR)/Make.global
+
+### Allow user defined options to overwrite defaults:
+
+-include $(VDRDIR)/Make.config
+
 ### Implicit rules:
 
 %.o: %.c
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.c vdr-1.7.32/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.c
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.c	2011-10-16 17:12:49.000000000 +0200
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.c	2012-11-13 21:19:39.000000000 +0100
@@ -449,3 +449,22 @@
     osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
     return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
 }
+
+int HdffCmdAvSetSyncShift(int OsdDevice, int16_t SyncShift)
+{
+    uint8_t cmdData[16];
+    BitBuffer_t cmdBuf;
+    osd_raw_cmd_t osd_cmd;
+
+    BitBuffer_Init(&cmdBuf, cmdData, sizeof(cmdData));
+    memset(&osd_cmd, 0, sizeof(osd_raw_cmd_t));
+    osd_cmd.cmd_data = cmdData;
+    HdffCmdBuildHeader(&cmdBuf, HDFF_MSG_TYPE_COMMAND,
+                       HDFF_MSG_GROUP_AV_DECODER,
+                       HDFF_MSG_AV_SET_OPTIONS);
+    BitBuffer_SetBits(&cmdBuf, 1, 1);
+    BitBuffer_SetBits(&cmdBuf, 31, 0); // reserved
+    BitBuffer_SetBits(&cmdBuf, 16, SyncShift);
+    osd_cmd.cmd_len = HdffCmdSetLength(&cmdBuf);
+    return ioctl(OsdDevice, OSD_RAW_CMD, &osd_cmd);
+}
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h vdr-1.7.32/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h	2012-02-05 20:25:33.000000000 +0100
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_av.h	2012-11-13 21:19:39.000000000 +0100
@@ -149,4 +149,6 @@
 
 int HdffCmdAvSetAudioChannel(int OsdDevice, uint8_t AudioChannel);
 
+int HdffCmdAvSetSyncShift(int OsdDevice, int16_t SyncShift);
+
 #endif /* HDFFCMD_AV_H */
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h vdr-1.7.32/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h	2012-06-14 20:59:28.000000000 +0200
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/libhdffcmd/hdffcmd_defs.h	2012-11-13 21:19:39.000000000 +0100
@@ -70,6 +70,7 @@
     HDFF_MSG_AV_SET_AUDIO_DOWNMIX,
     HDFF_MSG_AV_SET_AUDIO_CHANNEL,
     HDFF_MSG_AV_SET_PLAY_MODE,
+    HDFF_MSG_AV_SET_OPTIONS,
 
     HDFF_MSG_MUX_SET_VIDEO_OUT = 0,
     HDFF_MSG_MUX_SET_SLOW_BLANK,
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/setup.c vdr-1.7.32/PLUGINS/src/dvbhddevice/setup.c
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/setup.c	2012-02-08 16:14:01.000000000 +0100
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/setup.c	2012-11-15 10:20:50.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: setup.c 1.17 2012/02/08 15:14:01 kls Exp $
+ * $Id: setup.c 1.18 2012/11/15 09:20:50 kls Exp $
  */
 
 #include "setup.h"
@@ -26,6 +26,7 @@
     AnalogueVideo = HDFF_VIDEO_OUT_CVBS_YUV;
     AudioDelay = 0;
     AudioDownmix = HDFF_AUDIO_DOWNMIX_AUTOMATIC;
+    AvSyncShift = 0;
     OsdSize = 0;
     CecEnabled = 1;
     CecTvOn = 1;
@@ -46,6 +47,7 @@
     else if (strcmp(Name, "AnalogueVideo")     == 0) AnalogueVideo     = atoi(Value);
     else if (strcmp(Name, "AudioDelay")        == 0) AudioDelay        = atoi(Value);
     else if (strcmp(Name, "AudioDownmix")      == 0) AudioDownmix      = atoi(Value);
+    else if (strcmp(Name, "AvSyncShift")       == 0) AvSyncShift       = atoi(Value);
     else if (strcmp(Name, "OsdSize")           == 0) OsdSize           = atoi(Value);
     else if (strcmp(Name, "CecEnabled")        == 0) CecEnabled        = atoi(Value);
     else if (strcmp(Name, "CecTvOn")           == 0) CecTvOn           = atoi(Value);
@@ -256,6 +258,7 @@
     Add(new cMenuEditStraItem(tr("Analogue Video"), &mNewHdffSetup.AnalogueVideo, kAnalogueVideos, AnalogueVideoItems));
     Add(new cMenuEditIntItem(tr("Audio Delay (ms)"), &mNewHdffSetup.AudioDelay, 0, 500));
     Add(new cMenuEditStraItem(tr("Audio Downmix"), &mNewHdffSetup.AudioDownmix, kAudioDownmixes, AudioDownmixItems));
+    Add(new cMenuEditIntItem(tr("A/V Sync Shift (ms)"), &mNewHdffSetup.AvSyncShift, -500, 500));
     Add(new cMenuEditStraItem(tr("OSD Size"), &mNewHdffSetup.OsdSize, kOsdSizes, OsdSizeItems));
     Add(new cMenuEditBoolItem(tr("HDMI CEC"), &mNewHdffSetup.CecEnabled));
     Add(new cMenuEditBoolItem(tr("CEC: Switch TV on"), &mNewHdffSetup.CecTvOn));
@@ -385,6 +388,7 @@
     SetupStore("AnalogueVideo", mNewHdffSetup.AnalogueVideo);
     SetupStore("AudioDelay", mNewHdffSetup.AudioDelay);
     SetupStore("AudioDownmix", mNewHdffSetup.AudioDownmix);
+    SetupStore("AvSyncShift", mNewHdffSetup.AvSyncShift);
     SetupStore("OsdSize", mNewHdffSetup.OsdSize);
     SetupStore("CecEnabled", mNewHdffSetup.CecEnabled);
     SetupStore("CecTvOn", mNewHdffSetup.CecTvOn);
@@ -412,6 +416,7 @@
 
         mHdffCmdIf->CmdAvSetAudioDelay(mNewHdffSetup.AudioDelay);
         mHdffCmdIf->CmdAvSetAudioDownmix((HdffAudioDownmixMode_t) mNewHdffSetup.AudioDownmix);
+        mHdffCmdIf->CmdAvSetSyncShift(mNewHdffSetup.AvSyncShift);
 
         mHdffCmdIf->CmdMuxSetVideoOut((HdffVideoOut_t) mNewHdffSetup.AnalogueVideo);
 
diff -ruN vdr-1.7.31/PLUGINS/src/dvbhddevice/setup.h vdr-1.7.32/PLUGINS/src/dvbhddevice/setup.h
--- vdr-1.7.31/PLUGINS/src/dvbhddevice/setup.h	2012-02-08 16:14:56.000000000 +0100
+++ vdr-1.7.32/PLUGINS/src/dvbhddevice/setup.h	2012-11-15 10:21:07.000000000 +0100
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: setup.h 1.12 2012/02/08 15:14:56 kls Exp $
+ * $Id: setup.h 1.13 2012/11/15 09:21:07 kls Exp $
  */
 
 #ifndef _HDFF_SETUP_H_
@@ -28,6 +28,7 @@
     int AnalogueVideo;
     int AudioDelay;
     int AudioDownmix;
+    int AvSyncShift;
     int OsdSize;
     int CecEnabled;
     int CecTvOn;
diff -ruN vdr-1.7.31/ci.c vdr-1.7.32/ci.c
--- vdr-1.7.31/ci.c	2012-05-29 13:13:40.000000000 +0200
+++ vdr-1.7.32/ci.c	2012-10-07 13:11:18.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.c 2.9 2012/05/29 11:13:40 kls Exp $
+ * $Id: ci.c 2.10 2012/10/07 11:11:18 kls Exp $
  */
 
 #include "ci.h"
@@ -845,9 +845,9 @@
      int D = tm_gmt.tm_mday;
      int L = (M == 1 || M == 2) ? 1 : 0;
      int MJD = 14956 + D + int((Y - L) * 365.25) + int((M + 1 + L * 12) * 30.6001);
-#define DEC2BCD(d) (((d / 10) << 4) + (d % 10))
+#define DEC2BCD(d) uint8_t(((d / 10) << 4) + (d % 10))
      struct tTime { uint16_t mjd; uint8_t h, m, s; short offset; };
-     tTime T = { mjd : htons(MJD), h : DEC2BCD(tm_gmt.tm_hour), m : DEC2BCD(tm_gmt.tm_min), s : DEC2BCD(tm_gmt.tm_sec), offset : htons(tm_loc.tm_gmtoff / 60) };
+     tTime T = { mjd : htons(MJD), h : DEC2BCD(tm_gmt.tm_hour), m : DEC2BCD(tm_gmt.tm_min), s : DEC2BCD(tm_gmt.tm_sec), offset : short(htons(tm_loc.tm_gmtoff / 60)) };
      bool OldDumpTPDUDataTransfer = DumpTPDUDataTransfer;
      DumpTPDUDataTransfer &= DumpDateTime;
      if (DumpDateTime)
diff -ruN vdr-1.7.31/config.h vdr-1.7.32/config.h
--- vdr-1.7.31/config.h	2012-09-15 13:51:54.000000000 +0200
+++ vdr-1.7.32/config.h	2012-10-03 11:59:34.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.53 2012/09/15 11:51:54 kls Exp $
+ * $Id: config.h 2.54 2012/10/03 09:59:34 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.31"
-#define VDRVERSNUM   10731  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.32"
+#define VDRVERSNUM   10732  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.31"
-#define APIVERSNUM   10731  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.32"
+#define APIVERSNUM   10732  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
